/*
 * Bachelor.c
 *
 * Created: 10.4.2014 10:25:00
 *  Author: Martin Hortvk
 */ 

#define F_CPU 16000000UL    // frekvence pouitho krystalu

#include <avr/io.h>
#include <string.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "twi_lib.h"		// hlavikov soubor knihovny pro prci s I2C sbrnic

//*******************************************************************************************

#define RTC 0xA0			// adresa obvodu RTC
#define sekundy 0x02		// adresa registru sekundy
#define minuty 0x03			// adresa registru minut

//*******************************************************************************************

#define setb(port,pin)    port |= 1<<pin    //set bit
#define clrb(port,pin)    port &= ~(1<<pin) //clear bit
#define negb(port,pin)    port ^= 1<<pin    //revert bit

//***********************************************************************************

unsigned char BCD;						// promnn, do kter zapisujem vstup z registru RTC
int current_min = -1;					// nastaven rozdlnch hodnot - proveden impulsu pi startu
int last_min = -2;
int flag = 0;							// pznak - std vstupn piny

unsigned char read(bunka)
{
  i2c_start_wait(RTC+I2C_WRITE);		// Vysln start bitu, adresy RTC a bitu pro zpis (ten, zpis) (S ADR R/\W)
  i2c_write(bunka);						// Vysln datov adresy, ze kter se m st
  i2c_rep_start(RTC+I2C_READ);   		// Vysln znovu start bitu, adresy RTC a bitu pro ten (ten, zpis) (S ADR R/\W)
  BCD = i2c_readNak();               	// Peten celho bytu z vyslan adresy
  i2c_stop();                         	// Vysln Stop bitu, ukonen komunikace
}

void initStream()
{	
	DDRC=0xFF;							//nastaven pin portu C jako vstup
}

int main(void)
{
	initStream();
	i2c_init();							// inicializace komunikace
	
	PORTC=0x00;							// vstupn piny portu C nastavit na log. 0
	
	//minutes_low = 0x0f & BCD;		 	// Pevod jednotek minut z BCD
	//minutes_high = (BCD>>4) & 0x0f;	// Pevod destek minut z BCD - v tomto ppad nen nutno pevdt

    while(1)
    {
		read(minuty);						// ten minut
		current_min = 0x0f & BCD;			// Pevod jednotek minut z BCD

		if (current_min != last_min)		// pokud se minutov daj zmnil, generuj impuls
		{
			setb(PORTC, flag);				// aktivace vstupnho pinu
			
			_delay_ms(1000);				// ekej 1 sec
			
			clrb(PORTC, flag);				// deaktivace vstupnho pinu
			
			if (flag == 0) {				// vmna hodnoty pznaku (vstupnho pinu)
				flag = 1;
			} 
			else if (flag == 1){
				flag = 0;
			}
			
			last_min = current_min;			// uloen aktuln hodnoty minut k dalmu porovnn
		}
    }
}